#include "GV.h"

int search_bullet_num();
void fire_enter(double x,double y,int color);


int search_tutu_num(){
	int i;
	for(i=0;i<TUTU_MAX;i++){
		if(tutu[i].flag==0){
			return i;
		}
	}
	return -1;
}

void ch_set_tutu(){
	int i;

	if(ch.charge_count>0){
		ch.charge_count--;
	}

	else if(CheckStatePad(configpad.down)==1){
		i=search_tutu_num();
		if(i!=-1){
			tutu[i].flag=1;
			tutu[i].count=0;
			tutu[i].x=ch.x;
			ch.charge_count=60;
		}
	}
}

void ch_pitagoraswitch(){
	int i,j;
	if(ch.pitagora_count==8){
		if(CheckStatePad(configpad.up)==1){
			ch.pitagora_count=0;
			for(i=0;i<32;i++){
				j=search_bullet_num();
				if(j!=-1){
					bullet[j].flag=1;
					bullet[j].x=32+GetRand(640-64);
					bullet[j].y=450+GetRand(240);
					bullet[j].pitagora=1;
					bullet[j].count=0;
				}
			}
		}
	}
}

void ch_move(){
	if(CheckStatePad(configpad.right)>0){
		ch.x+=4;
		if(ch.x>640-16){
			ch.x=640-16;
		}
	}
	if(CheckStatePad(configpad.left)>0){
		ch.x-=4;
		if(ch.x<16){
			ch.x=16;
		}
	}
}


void ch_main(){
	ch_set_tutu();
	ch_pitagoraswitch();
	ch_move();
}

int search_bullet_num(){
	int i;
	for(i=0;i<BULLET_MAX;i++){
		if(bullet[i].flag==0){
			return i;
		}
	}
	return -1;
}

void tutu_main(){
	int i,j;
	for(i=0;i<TUTU_MAX;i++){
		if(tutu[i].flag==1){
			if(tutu[i].count==120){
				j=search_bullet_num();
				if(j!=-1){
					bullet[j].flag=1;
					bullet[j].x=tutu[i].x;
					bullet[j].y=412-16;
					bullet[j].pitagora=0;
				}
			}
			if(tutu[i].count==180){
				tutu[i].flag=0;
			}
			tutu[i].count++;
		}
	}
}

void bullet_main(){
	for(int i=0;i<BULLET_MAX;i++){
		if(bullet[i].flag==1){
			bullet[i].y-=3;
			if(bullet[i].y<-20){
				bullet[i].flag=0;
			}
			if(bullet[i].pitagora==1){
				if(bullet[i].count==120){
					fire_enter(bullet[i].x,bullet[i].y,GetRand(7));
					for(int j=0;j<ENEMY_MAX;j++){
						if(enemy[j].flag==1){
							enemy[j].flag=0;
							ch.score++;
						}
					}
					bullet[i].flag=0;
				}
				bullet[i].count++;
			}
		}
	}
}

int search_enemy_num(){
	for(int i=0;i<ENEMY_MAX;i++){
		if(enemy[i].flag==0){
			return i;
		}
	}
	return -1;
}

void enemy_enter(){
	int i;
	if(game_count%180==179){
		if(enemy_count<50){
			i=search_enemy_num();
			if(i!=-1){
				enemy[i].flag=1;
				enemy[i].x=32+GetRand(640-32*2);
				enemy[i].y=-20;
				enemy_count++;
			}
		}
	}
}

void enemy_main(){
	enemy_enter();
	for(int i=0;i<ENEMY_MAX;i++){
		if(enemy[i].flag==1){
			enemy[i].y++;
			if(enemy[i].y>412-16){
				enemy[i].flag=0;
				ch.hp--;
				if(ch.hp==0){
					if(ch.score==0){
						achievement_flag[0]=1;
					}
					func_state=FS_GAMEOVER;
				}
			}
		}
	}
}

int search_fire_num(){
	for(int i=0;i<FIRE_MAX;i++){
		if(fire[i].flag==0){
			return i;
		}
	}
	return -1;
}

void fire_enter(double x,double y,int color){
	int i,j,k;
	for(i=0;i<4;i++){
		for(j=0;j<16;j++){
			k=search_fire_num();
			if(k!=-1){
				fire[k].flag=1;
				fire[k].count=0;
				fire[k].angle=PI2/16*j;
				fire[k].speed=i;
				fire[k].x=x;
				fire[k].y=y;
				fire[k].color=color;
			}
		}
	}
}

void fire_main(){
	for(int i=0;i<FIRE_MAX;i++){
		if(fire[i].flag==1){
			fire[i].x+=fire[i].speed*cos(fire[i].angle);
			fire[i].y+=fire[i].speed*sin(fire[i].angle);
			if(fire[i].count==30){
				fire[i].flag=0;
			}
			fire[i].count++;
		}
	}
}

void hit_main(){
	int i,j;
	for(i=0;i<ENEMY_MAX;i++){
		if(enemy[i].flag==1){
			for(j=0;j<BULLET_MAX;j++){
				if(bullet[j].flag==1){
					if(bullet[j].x-enemy[i].x>-24
					&& bullet[j].x-enemy[i].x< 24
					&& bullet[j].y-enemy[i].y>-24
					&& bullet[j].y-enemy[i].y< 24){
						enemy[i].flag=0;
						bullet[j].flag=0;
						ch.score++;
						if(ch.pitagora_count<8 && bullet[j].pitagora==0){
							ch.pitagora_count++;
						}
						fire_enter(bullet[j].x,bullet[j].y,(ch.score-1)%8);
					}
				}
			}
			if(enemy[i].y>412-16-32){
				if(ch.x-enemy[i].x>-16
				&& ch.x-enemy[i].x<16){
					ch.hp=0;
					if(ch.score==0){
						achievement_flag[0]=1;
					}
					func_state=FS_GAMEOVER;
				}
			}
		}
	}
}

void clear_check(){
	int flag=0;
	if(enemy_count==50){
		flag=1;
		for(int i=0;i<ENEMY_MAX;i++){
			if(enemy[i].flag==1){
				flag=0;
				break;
			}
		}
		if(flag==1){
			func_state=FS_CLEAR;
		}
	}
}

